## liblip 2.0.0

=== examples/Makefile ===
#############################################################################
#									    #
#	CLASS LIBRARY LIP FOR MULTIVARIATE SCATTERED DATA INTERPOLATION     #
#									    #
#	This makefile gives targets that show how to compile and link       #
#	user code to the Lip shared library and statatic library.           #
#									    #
#############################################################################
#
# This make file show how to compile and link examples included with this 
# distribution of LIP assuming different installations of the library. this
# include the following examples for both static and shared linking.
#
# liblipex:		shows how to compile and link library when install
#			in the library search path used to load libraries
#
# exampleprocedural:		shows how to compile and link by implicitly telling
#			 the linker where to look for the library
#			 shows how to compile and link procedural C conde.
#
############################################################################

# location where the library is installed
MYPATH= /home/user1/liblip.2.0

# compiler
CC = g++
GCC = gcc

# Some options probably not needed: -g (which enables the debugger options).
FLAGS = -g -O -Wno-deprecated

# Object file fo the example
OBJ1 = liblipex.o
OBJ2 = exampleprocedural.o

# LIB_PATH used to store the path in which the library files were installed.
# The commented out assignment is for when the library is installed into the
# users home directory. NOTE: $(HOME) referes to env varialble HOME.

#directory where the liblip.a is installed
LIB_PATH = $(MYPATH)/lib/
#LIB_PATH = /usr/local/lib/

# INCLUDE_PATH used to store the path in which the *.h files have been
# placed. The commented out assignment is for when the *.h files are placed
# in the users home directory.

#directory
INCLUDE_PATH = $(MYPATH)/include
#INCLUDE_PATH = /usr/local/include/

#include directories holdign the header files needed for liblip
#INCLUDE= -I$(INCLUDE_PATH)/tnt  -I$(INCLUDE_PATH)/glpk -I$(INCLUDE_PATH)
INCLUDE= -I$(INCLUDE_PATH)/tnt  -I$(INCLUDE_PATH)

#location of glpklib.a this is a static library and should be compiled from source.
GLPK_STATIC_PATH=$(HOME)/glpklib/lib/

all:	static_example2  static_example shared_example 

#################################################################################
# linking examplelint. If you have succesfully installed lip library and have
# LIB_PATH to /etc/ld.so.conf Or you have added LIB_PATH TO LD_LIBRARY_PATH
# then compiling is as eassy as this.  

# shared_example target links liblipex.o to the liblip shared library. To make
# up shared_example executable.

shared_example:	$(OBJ1)
		$(CC) -o shared_example $(OBJ1) $(FLAGS) -L$(LIB_PATH) -llip -L$(GLPK_STATIC_PATH) -lglpk -lm

# static_example target links liblipex.o to the liblip static library. To make
# up static_example executable.

static_example: $(OBJ1)
		$(CC) -o static_example -non_shared  $(OBJ1) $(FLAGS) -L$(LIB_PATH) -llip -L$(GLPK_STATIC_PATH) -lglpk -lm


#################################################################################
# linking examplelintprocedural

# static_example target links exampleprocedural.o to the lip static library. To make
# up static_example executable.

static_example2:$(OBJ2)
		$(CC) -o static_example2 -static $(OBJ2) $(FLAGS) $(LIB_PATH)liblip.a  $(GLPK_STATIC_PATH)libglpk.a -lm


#################################################################################
# compiling examples to objectfiles.

liblipex.o:			liblipex.cpp
				$(CC) -c liblipex.cpp $(FLAGS) $(INCLUDE)

# compiling proccedual example using C compiler
#
exampleprocedural.o:	exampleprocedural.c
				$(GCC) -c exampleprocedural.c $(FLAGS) $(INCLUDE)

.PHONY: clean all

clean:
		rm -f $(OBJ1) shared_example static_example
		rm -f $(OBJ2) static_example2

=== debian/changelog ===
liblip (2.0.0-4) unstable; urgency=medium

  * QA upload.
  * Migrate some basic part of the packaging to use classic debhelper.
    Migrating to use `dh` is for another day.
  * Set `Rules-Requires-Root` to `no`.

 -- Niels Thykier <niels@thykier.net>  Wed, 06 Nov 2024 19:35:16 +0000

liblip (2.0.0-3) unstable; urgency=medium

  * QA upload.

  * Added d/gbp.conf to describe branch layout.
  * Updated vcs in d/control to Salsa.
  * Updated d/gbp.conf to enforce the use of pristine-tar.
  * Updated Standards-Version from 3.7.2 to 4.7.0.
  * Use wrap-and-sort -at for debian control files
  * debian/control: Remove empty control field Conflicts in
    package liblip2t64.
  * Remove field Priority on binary packages liblip-dev, liblip2t64
    that duplicates source.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 15 Jun 2024 12:57:07 +0200

liblip (2.0.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062399

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 23:44:01 +0000

liblip (2.0.0-2) unstable; urgency=medium

  * QA upload.
  * Convert to source format 3.0.

 -- Bastian Germann <bage@debian.org>  Wed, 09 Aug 2023 17:43:43 +0200

liblip (2.0.0-1.5) unstable; urgency=medium

  * Non-maintainer upload.

  [ Helmut Grohne ]
  * Support cross-building (Closes: #1001513)

 -- Vagrant Cascadian <vagrant@reproducible-builds.org>  Thu, 15 Dec 2022 14:21:26 -0800

liblip (2.0.0-1.4) unstable; urgency=medium

  * Non-maintainer upload.

  [ Nilesh Patra ]
  * Build reproducibly (Closes: #989583)

 -- Vagrant Cascadian <vagrant@reproducible-builds.org>  Thu, 15 Dec 2022 13:49:39 -0800

liblip (2.0.0-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/rules: Add build-{arch,indep} (Closes: #999142).

 -- Marcos Talau <talau@debian.org>  Thu, 03 Nov 2022 16:18:09 -0300

liblip (2.0.0-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * Add autotools-dev for updated config.{sub,guess} (Closes: #534817)

 -- Chen Baozi <baozich@gmail.com>  Thu, 05 Jun 2014 16:22:13 +0800

liblip (2.0.0-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * debian/rules:
    - Fix bashisms (Closes: #378597).
    - Fix debian-rules-ignores-make-clean-error lintian warnings.
  * debian/control:
    - Move to new Homepage field.
    - Use ${binary:Version} instead of deprecated ${Source-Version},
      fix substvar-source-version-is-deprecated lintian warning.
  * debian/shlibs:
    - Move to liblip2, fix shlibs-declares-dependency-on-other-package
      lintian warning.

 -- Luca Falavigna <dktrkranz@ubuntu.com>  Tue, 15 Jan 2008 20:48:51 +0100

liblip (2.0.0-1) unstable; urgency=low

  * New upstream release.

 -- Juan Esteban Monsalve Tobon <esteban@v7w.com>  Sun, 16 Jul 2006 16:13:29 +1000

liblip (1.2-3) unstable; urgency=low

  * New maintainer.

 -- Juan Esteban Monsalve Tobon <esteban@v7w.com>  Sun, 10 Apr 2005 12:58:01 +1000

liblip (1.2-2) unstable; urgency=low

  * Fixed "FTBFS with gcc-3.4: 'data' undeclared" (Closes: #280289).
    Patch by Andreas Jochens <aj@andaco.de>.
  * New maintainer's email address.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Fri, 18 Feb 2005 16:51:20 +1100

liblip (1.2-1) unstable; urgency=low

  * New upstream release.

 -- Anibal Monsalve Salazar <A.Monsalve.Salazar@IEEE.org>  Thu, 26 Aug 2004 17:53:28 +1000

liblip (1.0-1) unstable; urgency=low

  * Initial release (Closes: #249394).

 -- Anibal Monsalve Salazar <A.Monsalve.Salazar@IEEE.org>  Thu, 20 May 2004 05:46:32 +1000

=== debian/control ===
Source: liblip
Section: math
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: autotools-dev,
               debhelper-compat (= 13),
               dpkg-dev (>= 1.22.5),
               libtnt-dev (>= 1.2.5-3),
Homepage: http://www.deakin.edu.au/~gleb/lip.html
Rules-Requires-Root: no
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/liblip
Vcs-Git: https://salsa.debian.org/debian/liblip.git

Package: liblip2t64
Provides: ${t64:Provides},
Replaces: liblip2,
Breaks: liblip2 (<< ${source:Version}),
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
Description: reliable interpolation of multivariate scattered data
 Lip interpolates scattered multivariate data with a Lipschitz function.
 .
 Methods of interpolation of multivariate scattered data are scarce.
 The programming library Lip implements a
 new method by G. Beliakov, which relies on building reliable lower and
 upper approximations of Lipschitz functions. If we assume that the
 function that we want to interpolate is Lipschitz-continuous, we can
 provide tight bounds on its values at any point, in the worse case
 scenario. Thus we obtain the interpolant, which approximates the unknown
 Lipschitz function f  best in the worst case scenario. This translates
 into reliable learning of f, something that other methods cannot do (the
 error of approximation of most other methods can be infinitely large,
 depending on what f generated the data).
 .
 Lipschitz condition implies that the rate of change of the function is
 bounded:
 .
 |f(x)-f(y)|<M||x-y||.
 .
 It is easily interpreted as the largest slope of the function f. f needs
 not be differentiable.
 .
 The interpolant based on the Lipschitz properties of the function is
 piecewise linear, it possesses many useful properties, and it is shown
 that it is the best possible approximation to f in the worst case
 scenario. The value of the interpolant depends on the data points in the
 immediate neigbourhood of the point in question, and in this sense, the
 method is similar to the natural neighbour interpolation.
 .
 There are two methods of construction and evaluation of the interpolant.
 The explicit method processes all data points to find the neighbours of
 the point in question. It does not require any preprocessing, but the
 evaluation of the interpolant has linear complexity O(K) in terms of the
 number of data.
 .
 "Fast" method requires substantial preprocessing in the case of more
 than 3-4 variables, but then it provides O(log K) evaluation time, and
 thus is suitable for very large data sets (K of order of 500000) and
 modest dimension (n=1-4). For larger dimension, explicit method becomes
 practically more efficient. The class library Lip implements both fast
 and explicit methods.

Package: liblip-dev
Section: libdevel
Architecture: any
Depends: liblip2t64 (= ${binary:Version}),
         libtnt-dev,
         ${shlibs:Depends},
Description: reliable interpolation of multivariate scattered data
 Lip interpolates scattered multivariate data with a Lipschitz function.
 .
 Methods of interpolation of multivariate scattered data are scarce.
 The programming library Lip implements a
 new method by G. Beliakov, which relies on building reliable lower and
 upper approximations of Lipschitz functions. If we assume that the
 function that we want to interpolate is Lipschitz-continuous, we can
 provide tight bounds on its values at any point, in the worse case
 scenario. Thus we obtain the interpolant, which approximates the unknown
 Lipschitz function f  best in the worst case scenario. This translates
 into reliable learning of f, something that other methods cannot do (the
 error of approximation of most other methods can be infinitely large,
 depending on what f generated the data).
 .
 Lipschitz condition implies that the rate of change of the function is
 bounded:
 .
 |f(x)-f(y)|<M||x-y||.
 .
 It is easily interpreted as the largest slope of the function f. f needs
 not be differentiable.
 .
 The interpolant based on the Lipschitz properties of the function is
 piecewise linear, it possesses many useful properties, and it is shown
 that it is the best possible approximation to f in the worst case
 scenario. The value of the interpolant depends on the data points in the
 immediate neigbourhood of the point in question, and in this sense, the
 method is similar to the natural neighbour interpolation.
 .
 There are two methods of construction and evaluation of the interpolant.
 The explicit method processes all data points to find the neighbours of
 the point in question. It does not require any preprocessing, but the
 evaluation of the interpolant has linear complexity O(K) in terms of the
 number of data.
 .
 "Fast" method requires substantial preprocessing in the case of more
 than 3-4 variables, but then it provides O(log K) evaluation time, and
 thus is suitable for very large data sets (K of order of 500000) and
 modest dimension (n=1-4). For larger dimension, explicit method becomes
 practically more efficient. The class library Lip implements both fast
 and explicit methods.

=== debian/rules ===
#!/usr/bin/make -f
# Copyright (C) 2004-2005 Anibal Monsalve Salazar <anibal@debian.org>
# Copyright (c) 2005 Juan Esteban Monsalve Tobon <esteban@v7w.com>

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildtools.mk

STRIP      := $(STRIP) --strip-unneeded --remove-section=.comment --remove-section=.note

CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
CXXFLAGS += -ffile-prefix-map=$(CURDIR)=.

build-arch:
	dh_testdir
	dh_update_autotools_config
	dh_autoreconf
	./configure --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE) --prefix=/usr --enable-shared	./configure --prefix=/usr --enable-shared
	$(MAKE) install prefix=$(CURDIR)/shared CXXFLAGS="$(CXXFLAGS)"
	[ ! -f Makefile ] || $(MAKE) distclean
	-rm -f config.log config.cache
	./configure --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE) --prefix=/usr --enable-static
	$(MAKE) install prefix=$(CURDIR)/static CXXFLAGS="$(CXXFLAGS)"
	touch build

clean:
	dh_testdir
	-rm -f build
	[ ! -f Makefile ] || $(MAKE) distclean
	-rm -f config.log config.cache
	-rm -rf tnt shared static
	dh_autoreconf_clean
	dh_clean

binary-indep: build-indep

binary-arch: build-arch
	dh_testdir
	dh_prep
	install -d debian/liblip2t64/usr/share/doc/liblip2t64/examples
	cd debian && install -d liblip2t64 liblip-dev
	cd debian/liblip2t64    && install -d usr/share/doc usr/lib/lip
	cd debian/liblip-dev && install -d usr/share/doc usr/lib/lip usr/include/lip
	cd shared/lib && $(STRIP) --strip-unneeded liblip.so.2.0.0
	cd static/lib && strip --strip-debug liblip.a

	mv shared/lib/liblip.so.* debian/liblip2t64/usr/lib/lip
	mv shared/lib/liblip.so debian/liblip-dev/usr/lib/lip	
	sed "s/^libdir=.*/libdir=\'\/usr\/lib\/lip\'/" shared/lib/liblip.la > debian/liblip-dev/usr/lib/lip/liblip.la
	mv static/lib/liblip.a debian/liblip-dev/usr/lib/lip	
	sed "s/^#include \"forest.h\"/#include <lip\/forest.h>/" static/include/interpol.h > debian/liblip-dev/usr/include/lip/interpol.h
	sed "s/^#include \"memblock.h\"/#include <lip\/memblock.h>/" static/include/forest.h > debian/liblip-dev/usr/include/lip/forest.h
	mv static/include/liblip.h debian/liblip-dev/usr/include/lip
	mv static/include/memblock.h debian/liblip-dev/usr/include/lip

	dh_installdocs --link-doc=liblip2t64 docs/*
	dh_installchangelogs
	dh_installexamples -v examples/example* examples/Makefile
	dh_fixperms
	dh_compress

	dh_makeshlibs
	dh_shlibdeps

	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch

build: build-arch build-indep
build-indep: build

.PHONY: binary binary-arch binary-indep build-arch build-indep clean
